// HookKeyHook.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <tlhelp32.h>

#include "PhoneStatusUtil.h" 

/* Defines */
#define		HOOKKEYHOOK_MUTEX_NAME		_T("HookKeyHook App Mutex")
#define		HOOKKEYHOOK_STOP_EVENT		_T("HookKeyHook App Stop Event")
#define		HOOKKEYHOOK_SETTING_REGKEY	_T("Software\\HookKeyHook")
#define		HOOKKEYHOOK_OFFHOOK_PATH	_T("OffHookKey_cmd")
#define		HOOKKEYHOOK_OFFHOOK_ARG		_T("OffHookKey_arg")
#define		HOOKKEYHOOK_ONHOOK_PATH		_T("OnHookKey_cmd")
#define		HOOKKEYHOOK_ONHOOK_ARG		_T("OnHookKey_arg")
#define		HOOKKEYHOOK_SLIDEOPEN_PATH	_T("SlideOpen_cmd")
#define		HOOKKEYHOOK_SLIDEOPEN_ARG	_T("SlideOpen_arg")
#define		HOOKKEYHOOK_SLIDECLOSE_PATH	_T("SlideClose_cmd")
#define		HOOKKEYHOOK_SLIDECLOSE_ARG	_T("SlideClose_arg")

#define		ONHOOKKEY_EVENT_NAME		_T("OnHookKey")
#define		OFFHOOKKEY_EVENT_NAME		_T("OffHookKey")
#define		ONHOOKKEY_NEW_EVENT_NAME	_T("0nHookKey")
#define		OFFHOOKKEY_NEW_EVENT_NAME	_T("0ffHookKey")
#define		SLIDEOPEN_EVENT_NAME		_T("SlideOpen")
#define		SLIDECLOSE_EVENT_NAME		_T("SlideClose")
#define		SLIDEOPEN_NEW_EVENT_NAME	_T("$lideOpen")
#define		SLIDECLOSE_NEW_EVENT_NAME	_T("$lideClose")

#define		DENWA_WINDOW_TITLE				_T("db ")
#define		SHPHONEAPP_REG_PATH				_T("Software\\Sharp\\PhoneApp")
#define		LOCKPHONE_REG_VALUE_NAME		_T("LockPhone")
#define		KEYBOARD_DRIVERNAME_REG_PATH	_T("HARDWARE\\DEVICEMAP\\KEYBD")
#define		KEYBOARD_DRIVERNAME_VALUE_NAME	_T("DriverName")
#define		KEYBOARD_DEFAULT_DRIVER_DLLNAME	_T("d2keybd.dll")
#define		GWES_WND_CLASS_NAME				_T("TOUCHSTUBWND_CLASS")


/* Typedefs */
typedef struct _PATCHPROCESSINFO {
	DWORD		dwProcessId;
	LPBYTE		pBaseAddr;
	DWORD		dwBaseSize;
	DWORD		dwOnHookOffset;
	DWORD		dwOffHookOffset;
	DWORD		dwSlideOpenOffset;
	DWORD		dwSlideCloseOffset;
	BOOL		bPatched;
} PATCHPROCESSINFO;


// Global Variables:
HINSTANCE			g_hInst;				// The current instance


static
BOOL
GetKeybordDriverName(
	LPTSTR	pName,	// OUT
	DWORD	ccbName	// IN pName̕(NULLӂ)
)
{
	BOOL bRet;
	LONG lResult;
	HKEY hKey = NULL;

	bRet = FALSE;

	if (pName == NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, KEYBOARD_DRIVERNAME_REG_PATH, 0, NULL, &hKey);
	if (lResult == ERROR_SUCCESS) {

		DWORD dwType;
		DWORD dwSize;

		dwType = REG_SZ;
		dwSize = sizeof(TCHAR)*(ccbName-1);

		lResult = RegQueryValueEx(hKey, KEYBOARD_DRIVERNAME_VALUE_NAME, NULL, &dwType, (LPBYTE)pName, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}

		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
IsDenwaActive()
{
	BOOL	bRet;
	HWND	hWnd;
	TCHAR	szCaption[32];

	bRet = FALSE;

	hWnd = GetForegroundWindow();
	if (hWnd != NULL) {
		memset(szCaption, 0, sizeof(szCaption));
		GetWindowText(hWnd, szCaption, sizeof(szCaption)/sizeof(szCaption[0]));
		if (_tcscmp(szCaption, DENWA_WINDOW_TITLE) == 0) {
			bRet = TRUE;
		}
	}

	return bRet;
}

static
BOOL
IsLockPhone()
{
	BOOL	bRet;
	LRESULT lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, SHPHONEAPP_REG_PATH, 0, KEY_ALL_ACCESS, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = REG_DWORD;
		DWORD	dwValue = 0;
		DWORD	dwSize = 0;

		dwSize = sizeof(dwValue);
		lResult = RegQueryValueEx(hKey, LOCKPHONE_REG_VALUE_NAME, NULL, &dwType, (LPBYTE)&dwValue, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			if (dwValue != 0) {
				bRet = TRUE;
			}
		}

		CloseHandle(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
IsKeyLock()
{
	BOOL	bRet = FALSE;
	HKEY	hKey = NULL;

	bRet = FALSE;

	hKey = OpenPhoneStatus();
	if (hKey != NULL) {
		DWORD	dwValue = 0;

		GetPhoneStatus(hKey, 0, &dwValue);

		if (dwValue) {
			// L[bN
			bRet = TRUE;
		}
		else {
			// L[bNԂł͂Ȃ
			bRet = FALSE;
		}

		ClosePhoneStatus(hKey);
		hKey = NULL;
	}

	return bRet;
}


static
BOOL
ExecUserAction(
	LPTSTR	szCmdValueName,
	LPTSTR	szArgValueName
)
{
	BOOL	bRet;
	LONG	lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;	// default return value

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {
		TCHAR	szPath[MAX_PATH+1];
		TCHAR	szArg[MAX_PATH+1];
		DWORD	dwType = 0;
		DWORD	dwSize = 0;

		memset(szPath, 0, sizeof(szPath));
		dwSize = sizeof(szPath);
		lResult = RegQueryValueEx(hKey, szCmdValueName, NULL, &dwType, (LPBYTE)szPath, &dwSize);
		if (lResult == ERROR_SUCCESS && _tcslen(szPath) != 0) {
			BOOL				bCreateSucc = FALSE;
			PROCESS_INFORMATION pi;

			memset(&pi, 0, sizeof(pi));

			memset(szArg, 0, sizeof(szArg));
			dwSize = sizeof(szArg);
			lResult = RegQueryValueEx(hKey, szArgValueName, NULL, &dwType, (LPBYTE)szArg, &dwSize);
			if (lResult == ERROR_SUCCESS && _tcslen(szArg) != 0) {
				bCreateSucc = CreateProcess(szPath, szArg, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			}
			else {
				bCreateSucc = CreateProcess(szPath, NULL, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			}

			if (bCreateSucc) {
				CloseHandle(pi.hThread);
				CloseHandle(pi.hProcess);
			}

			bRet = TRUE;
		}

		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}


BOOL
NotifyOriginalEvent(
	LPTSTR	pEventName
)
{
	BOOL	bRet;
	HANDLE	hEvent;

	bRet = FALSE;

	hEvent = CreateEvent(NULL, FALSE, FALSE, pEventName);
	if (hEvent != NULL) {

		SetEvent(hEvent);
		CloseHandle(hEvent);
		hEvent = NULL;

		bRet = TRUE;
	}
	
	return bRet;
}

BOOL
doPatch(
	PATCHPROCESSINFO*	pPatchProcessInfo
)
{
	BOOL	bRet;
	HANDLE	hProcess = NULL;
	BYTE	bTmpBuf[32];
	DWORD	dwOnHookPatchOffset = 0;
	DWORD	dwOffHookPatchOffset = 0;
	DWORD	dwSlideOpenPatchOffset = 0;
	DWORD	dwSlideClosePatchOffset = 0;
	BOOL	bCanPatchOnHook = FALSE;
	BOOL	bCanPatchOffHook = FALSE;
	BOOL	bCanPatchSlideOpen = FALSE;
	BOOL	bCanPatchSlideClose = FALSE;

	bRet = FALSE;	// default return value

	if (pPatchProcessInfo == NULL) {
		return FALSE;
	}

	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pPatchProcessInfo->dwProcessId);
	if (hProcess != NULL) {
		DWORD	dwOffset = 0;
		BOOL	bReadSucc;
		BOOL	bWriteSucc;
		DWORD	dwRead;
		DWORD	dwWritten;

		// OnHooǩ
		// ̂ւ̃WbN͂߂Kɂ
		for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(ONHOOKKEY_EVENT_NAME); dwOffset++) {
			bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(ONHOOKKEY_EVENT_NAME), &dwRead);
			if (bReadSucc) {
				if (memcmp(bTmpBuf, ONHOOKKEY_EVENT_NAME, sizeof(ONHOOKKEY_EVENT_NAME)) == 0) {
					dwOnHookPatchOffset = dwOffset;
					bCanPatchOnHook = TRUE;

					break;
				}
			}
		}
		//

		// OffHooǩ
		// ̂ւ̃WbN͂߂Kɂ
		for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(OFFHOOKKEY_EVENT_NAME); dwOffset++) {
			bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(OFFHOOKKEY_EVENT_NAME), &dwRead);
			if (bReadSucc) {
				if (memcmp(bTmpBuf, OFFHOOKKEY_EVENT_NAME, sizeof(OFFHOOKKEY_EVENT_NAME)) == 0) {
					dwOffHookPatchOffset = dwOffset;
					bCanPatchOffHook = TRUE;

					break;
				}
			}
		}
		//

		// SlideOpeň
		// ̂ւ̃WbN͂߂Kɂ
		for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(SLIDEOPEN_EVENT_NAME); dwOffset++) {
			bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(SLIDEOPEN_EVENT_NAME), &dwRead);
			if (bReadSucc) {
				if (memcmp(bTmpBuf, SLIDEOPEN_EVENT_NAME, sizeof(SLIDEOPEN_EVENT_NAME)) == 0) {
					dwSlideOpenPatchOffset = dwOffset;
					bCanPatchSlideOpen = TRUE;

					break;
				}
			}
		}
		//

		// SlideClosě
		// ̂ւ̃WbN͂߂Kɂ
		for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(SLIDECLOSE_EVENT_NAME); dwOffset++) {
			bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(SLIDECLOSE_EVENT_NAME), &dwRead);
			if (bReadSucc) {
				if (memcmp(bTmpBuf, SLIDECLOSE_EVENT_NAME, sizeof(SLIDECLOSE_EVENT_NAME)) == 0) {
					dwSlideClosePatchOffset = dwOffset;
					bCanPatchSlideClose = TRUE;

					break;
				}
			}
		}
		//

		if (bCanPatchOnHook && bCanPatchOffHook && bCanPatchSlideOpen && bCanPatchSlideClose) {
			bWriteSucc = WriteProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr + dwOnHookPatchOffset, ONHOOKKEY_NEW_EVENT_NAME, sizeof(ONHOOKKEY_NEW_EVENT_NAME), &dwWritten);
			if (bWriteSucc) {
				bWriteSucc = WriteProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr + dwOffHookPatchOffset, OFFHOOKKEY_NEW_EVENT_NAME, sizeof(OFFHOOKKEY_NEW_EVENT_NAME), &dwWritten);
				if (bWriteSucc) {
					bWriteSucc = WriteProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr + dwSlideOpenPatchOffset, SLIDEOPEN_NEW_EVENT_NAME, sizeof(SLIDEOPEN_NEW_EVENT_NAME), &dwWritten);
					if (bWriteSucc) {
						bWriteSucc = WriteProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr + dwSlideClosePatchOffset, SLIDECLOSE_NEW_EVENT_NAME, sizeof(SLIDECLOSE_NEW_EVENT_NAME), &dwWritten);
						if (bWriteSucc) {

							pPatchProcessInfo->bPatched = TRUE;

							pPatchProcessInfo->dwOnHookOffset = dwOnHookPatchOffset;
							pPatchProcessInfo->dwOffHookOffset = dwOffHookPatchOffset;
							pPatchProcessInfo->dwSlideOpenOffset = dwSlideOpenPatchOffset;
							pPatchProcessInfo->dwSlideCloseOffset = dwSlideClosePatchOffset;

							bRet = TRUE;
						}
					}
				}
			}
		}
		
		CloseHandle(hProcess);
		hProcess = NULL;
	}

	return bRet;
}

BOOL
doRestore(
	PATCHPROCESSINFO*	pPatchProcessInfo
)
{
	BOOL	bRet = FALSE;
	HANDLE	hProcess = INVALID_HANDLE_VALUE;
	DWORD	dwWritten;

	if (pPatchProcessInfo == NULL) {
		return FALSE;
	}

	if (pPatchProcessInfo->bPatched) {
		// pb`čς̏ꍇ

		hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pPatchProcessInfo->dwProcessId);
		if (hProcess != INVALID_HANDLE_VALUE) {

			// OnHook̏C
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwOnHookOffset,
								ONHOOKKEY_EVENT_NAME,
								sizeof(ONHOOKKEY_EVENT_NAME),
								&dwWritten);
			//

			// OffHook̏C
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwOffHookOffset,
								OFFHOOKKEY_EVENT_NAME,
								sizeof(OFFHOOKKEY_EVENT_NAME),
								&dwWritten);
			//

			// SlideOpen̏C
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwSlideOpenOffset,
								SLIDEOPEN_EVENT_NAME,
								sizeof(SLIDEOPEN_EVENT_NAME),
								&dwWritten);
			//

			// SlideClosȅC
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwSlideCloseOffset,
								SLIDECLOSE_EVENT_NAME,
								sizeof(SLIDECLOSE_EVENT_NAME),
								&dwWritten);
			//

			CloseHandle(hProcess);
			hProcess = INVALID_HANDLE_VALUE;
			bRet = TRUE;
		}
	}

	return bRet;
}


BOOL
GetModuleLoadedAddr(
	DWORD	dwProcessID,	// IN
	LPTSTR	szModuleName,	// IN
	LPBYTE*	ppBaseAddr,		// OUT
	LPDWORD	pdwBaseSize		// OUT
)
{
	BOOL	bRet;
	HANDLE	hModuleSnap  = INVALID_HANDLE_VALUE;

	bRet = FALSE;

	hModuleSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessID);
	if (hModuleSnap != INVALID_HANDLE_VALUE) {

		BOOL			bGetEntrySucc;
		MODULEENTRY32	moduleEntry;

		memset(&moduleEntry, 0, sizeof(moduleEntry));
		moduleEntry.dwSize = sizeof(moduleEntry);

		bGetEntrySucc = Module32First(hModuleSnap, &moduleEntry);

		while (bGetEntrySucc) {

			if (_tcsicmp(szModuleName, moduleEntry.szModule) == 0) {
				*ppBaseAddr = moduleEntry.modBaseAddr;
				*pdwBaseSize = moduleEntry.modBaseSize;
				bRet = TRUE;
				break;
			}

			bGetEntrySucc = Module32Next(hModuleSnap, &moduleEntry);
		}

		CloseHandle(hModuleSnap);
		hModuleSnap = INVALID_HANDLE_VALUE;
	}

	return bRet;
}


BOOL
GetPatchProcessInfo(
	PATCHPROCESSINFO*	pProcessInfo
)
{
	BOOL	bRet;
	HWND	hWnd;
	DWORD	dwProcessId;
	LPBYTE	pBaseAddr = NULL;
	DWORD	dwBaseSize = 0;


	bRet = FALSE;

	if (pProcessInfo == NULL) {
		return FALSE;
	}

	hWnd = FindWindow(GWES_WND_CLASS_NAME, NULL);
	if (hWnd != NULL) {
		LPTSTR	pDriverName = NULL;
		TCHAR	szDriverName[256];

		GetWindowThreadProcessId(hWnd, &dwProcessId);

		// L[{[hhCo̎擾
		memset(szDriverName, 0, sizeof(szDriverName));
		if (GetKeybordDriverName(szDriverName, sizeof(szDriverName)/sizeof(szDriverName[0]))) {
			pDriverName = szDriverName;
		}
		else {
			// 擾łȂ΃ftHg
			pDriverName = KEYBOARD_DEFAULT_DRIVER_DLLNAME;
		}
		//

		if (GetModuleLoadedAddr(dwProcessId, pDriverName, &pBaseAddr, &dwBaseSize)) {

			memset(pProcessInfo, 0, sizeof(PATCHPROCESSINFO));

			pProcessInfo->dwProcessId = dwProcessId;
			pProcessInfo->pBaseAddr = pBaseAddr;
			pProcessInfo->dwBaseSize = dwBaseSize;

			bRet = TRUE;
		}
	}

	return bRet;
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{

	int					iRet;
	HANDLE				hStopEvent = NULL;
	HANDLE				hNewOnHookEvent = NULL;
	HANDLE				hNewOffHookEvent = NULL;
	HANDLE				hNewSlideOpenEvent = NULL;
	HANDLE				hNewSlideCloseEvent = NULL;
	HANDLE				hMutex = NULL;
	PATCHPROCESSINFO	patchProcessInfo;

	// dN`FbN
	hMutex = CreateMutex(NULL, TRUE, HOOKKEYHOOK_MUTEX_NAME);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {
			CloseHandle(hMutex);
			hMutex = NULL;

			iRet = MessageBox(NULL, _T("I܂?"), _T("HookKeyHook"), MB_YESNO|MB_ICONINFORMATION);
			if (iRet == IDYES) {

				hStopEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, HOOKKEYHOOK_STOP_EVENT);
				if (hStopEvent != NULL) {
					SetEvent(hStopEvent);
					CloseHandle(hStopEvent);
					hStopEvent = NULL;
				}
			}
			return FALSE;
		}
	}
	else {
		return FALSE;
	}
	//

	hStopEvent			= CreateEvent(NULL, FALSE, FALSE, HOOKKEYHOOK_STOP_EVENT);
	hNewOnHookEvent		= CreateEvent(NULL, FALSE, FALSE, ONHOOKKEY_NEW_EVENT_NAME);
	hNewOffHookEvent	= CreateEvent(NULL, FALSE, FALSE, OFFHOOKKEY_NEW_EVENT_NAME);
	hNewSlideOpenEvent	= CreateEvent(NULL, FALSE, FALSE, SLIDEOPEN_NEW_EVENT_NAME);
	hNewSlideCloseEvent	= CreateEvent(NULL, FALSE, FALSE, SLIDECLOSE_NEW_EVENT_NAME);

	if (hStopEvent != NULL && 
		hNewOnHookEvent != NULL && hNewOffHookEvent != NULL &&
		hNewSlideOpenEvent != NULL && hNewSlideCloseEvent != NULL ) {

		if (GetPatchProcessInfo(&patchProcessInfo)) {

			// vZXɃpb`𓖂Ă
			if (doPatch(&patchProcessInfo)) {

				DWORD	dwObject;
				HANDLE	phWaitEvents[5];
				BOOL	bStopRequest = FALSE;

				phWaitEvents[0] = hStopEvent;
				phWaitEvents[1] = hNewOnHookEvent;
				phWaitEvents[2] = hNewOffHookEvent;
				phWaitEvents[3] = hNewSlideOpenEvent;
				phWaitEvents[4] = hNewSlideCloseEvent;

				while (!bStopRequest) {
					dwObject = WaitForMultipleObjects(5, phWaitEvents, FALSE, INFINITE);
					switch(dwObject) {
					case WAIT_OBJECT_0:
						bStopRequest = TRUE;
						break;

					case WAIT_OBJECT_0 + 1:	// OnHook
						{
							if (IsLockPhone() || IsDenwaActive()) {
								NotifyOriginalEvent(ONHOOKKEY_EVENT_NAME);
							}
							else if (!IsKeyLock()) {
								// L[bNłȂ
								if (!ExecUserAction(HOOKKEYHOOK_ONHOOK_PATH, HOOKKEYHOOK_ONHOOK_ARG)) {
									// [U`̃ANVȂ΃IWiOnHook
									NotifyOriginalEvent(ONHOOKKEY_EVENT_NAME);
								}
							}
						}
						break;

					case WAIT_OBJECT_0 + 2:	// OffHook
						{
							if (IsLockPhone() || IsDenwaActive()) {
								NotifyOriginalEvent(OFFHOOKKEY_EVENT_NAME);
							}
							else if (!IsKeyLock()){
								// L[bNłȂ
								if (!ExecUserAction(HOOKKEYHOOK_OFFHOOK_PATH, HOOKKEYHOOK_OFFHOOK_ARG)) {
									// [U`̃ANVȂ΃IWiOffHook
									NotifyOriginalEvent(OFFHOOKKEY_EVENT_NAME);
								}
							}
						}
						break;

					case WAIT_OBJECT_0 + 3:	// SlideOpen
						NotifyOriginalEvent(SLIDEOPEN_EVENT_NAME);
						ExecUserAction(HOOKKEYHOOK_SLIDEOPEN_PATH, HOOKKEYHOOK_SLIDEOPEN_ARG);
						break;

					case WAIT_OBJECT_0 + 4:	// SlideClose
						NotifyOriginalEvent(SLIDECLOSE_EVENT_NAME);
						ExecUserAction(HOOKKEYHOOK_SLIDECLOSE_PATH, HOOKKEYHOOK_SLIDECLOSE_ARG);
						break;
					}
				}

				doRestore(&patchProcessInfo);

			}
//			else {
//				MessageBox(NULL, _T("pb`ĂɎs܂"), _T("HookKeyHook"), MB_OK|MB_SETFOREGROUND);
//			}

		}
	}

	if (hStopEvent != NULL) {
		CloseHandle(hStopEvent);
		hStopEvent = NULL;
	}
	if (hNewOnHookEvent != NULL) {
		CloseHandle(hNewOnHookEvent);
		hNewOnHookEvent = NULL;
	}
	if (hNewOffHookEvent != NULL) {
		CloseHandle(hNewOffHookEvent);
		hNewOffHookEvent = NULL;
	}
	if (hNewSlideOpenEvent != NULL) {
		CloseHandle(hNewSlideOpenEvent);
		hNewSlideOpenEvent = NULL;
	}
	if (hNewSlideCloseEvent != NULL) {
		CloseHandle(hNewSlideCloseEvent);
		hNewSlideCloseEvent = NULL;
	}

	return 0;
}
