#include "stdafx.h"

#include "PhoneStatusUtil.h"

/* Defines */
#define PHONESTATUS_REG_KEY		_T("Software\\Sharp\\PhoneStatus")
#define PHONESTATUS_VALUE_NAME	_T("Status%d")

HKEY
OpenPhoneStatus(
)
{
	HKEY	hKey = NULL;
	LONG	lResult;

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, PHONESTATUS_REG_KEY, 0, NULL, &hKey);
	if (lResult != ERROR_SUCCESS) {
		hKey = NULL;
	}

	return hKey;
}


void
ClosePhoneStatus(
	HKEY	hKey
)
{
	if (hKey != NULL) {
		RegCloseKey(hKey);
	}
}


BOOL
GetPhoneStatus(
	HKEY		hKey,		// IN
	int			iID,		// IN
	LPDWORD		pdwValue	// OUT
)
{
	TCHAR	szStatus[16];
	DWORD	dwVal;
	DWORD	dwSize;
	DWORD	dwType;
	LONG	lResult;
	BOOL	bRet;

	bRet = FALSE;

	if (hKey != NULL && pdwValue != NULL) {
		wsprintf(szStatus, PHONESTATUS_VALUE_NAME, iID);
		dwSize = sizeof(dwVal);
		lResult = RegQueryValueEx(hKey, szStatus, NULL, &dwType, (LPBYTE)&dwVal, &dwSize);

		if (lResult == ERROR_SUCCESS) {
			*pdwValue = dwVal;
			bRet = TRUE;
		}
	}

	return bRet;
}